unit Matrix;

interface

 type
  tmatrix = array of array of integer;

 procedure init(var m:TMatrix;n:integer);
 procedure display(var m:TMatrix);
 function plus(var m,n:TMatrix):TMatrix;
 function times(var m,n:TMatrix):TMatrix;

implementation

 procedure init(var m: TMatrix; n: integer);
 var i,j:integer;
 begin
  Randomize;
  setlength(m,n,n);
  for i := 0 to n - 1 do
   for j := 0 to n - 1 do
     m[i,j] := random(9)+1;
 end;

 procedure display(var m:TMatrix);
 var i,j:integer;
 begin
  for i := low(m) to high(m) do
  begin
   for j := low(m[i]) to high(m[i]) do
    write(m[i,j]:3);
   writeln;
  end;
 end;

 function plus(var m,n:TMatrix):TMatrix;
 var res:TMatrix;
     i,j:integer;
 begin
  setlength(res,length(m),length(m));
  for i := low(m) to high(m) do
   for j := low(m[i]) to high(m[i]) do
    res[i,j] := m[i,j] + n[i,j];
  plus := res;
 end;

 function times(var m,n:TMatrix):TMatrix;
 var res:TMatrix;
     i,j,k:integer;
 begin
  setlength(res,length(m), length(m));
  for i := low(m) to high(m) do
   for j := low(n[i]) to high(n[i]) do
   begin
    res[i,j] := 0;
    for k := low(m[i]) to high(m[i]) do
     res[i,j] := res[i,j] + m[i,k] * n[k,j];
   end;
  times := res;
 end;

end.
